{# Calculate the classes in a macro so they can be extracted elsewhere #}
{% macro linkClasses (dark = false, inline = false, circle = false) %}
	{# Note that if changing non-dark link classes, in order to see prose versions of these classes generated you will need to update the `safelist` in tailwind.config.ts #}
	{# Make sure to test the prose versions of these classes in the prose component when making changes #}
  {% set link_classes = [
		'group',
    'underline-offset-4', 'decoration-1',
    'hover:underline',
    'active:underline',
    'active:outline-none',
    'focus-visible:outline-offset-2', 'focus-visible:outline', 'focus-visible:outline-4', 'focus-visible:active:outline-none'
  ] %}

  {% if circle %}
    {% set link_classes = link_classes|merge([
			'focus-visible:rounded-full'
		]) %}
  {% else %}
    {% set link_classes = link_classes|merge([
      'focus-visible:rounded-[1px]'
		]) %}
  {% endif %}

	{% if inline %}
		{% set link_classes = link_classes|merge([
			'underline'
		]) %}
	{% else %}
		{% set link_classes = link_classes|merge([
			'no-underline'
		]) %}
	{% endif %}

  {% if dark %}
  	{# Dark / contrast colours #}
    {% set link_classes = link_classes|merge([
			'text-link-contrast',
      'decoration-link-contrast-underline',
			'hover:text-link-contrast-hover',
			'active:text-link-contrast-active',
      'focus:focus-dark'
    ]) %}
  {% else %}
  	{# Default / light colours #}
    {% set link_classes = link_classes|merge([
      'text-link-default',
      'decoration-link-underline',
      'hover:text-link-hover',
      'active:text-link-active',
      'focus:focus-light'
    ]) %}
  {% endif %}

	{# Output as space separated list #}
  {{ link_classes|join(' ') }}
{% endmacro %}

{% macro cardLinkClasses () %}
  {% set link_classes = _self.linkClasses(false, false) | split(" ") %}
  {% set link_classes = link_classes|filter(c => c != "active:underline" and c != "hover:underline")|merge([
    'group-hover:text-link-hover',
    'group-hover:no-underline',
    'hover:no-underline',
    'active:no-underline',
    'group-active:no-underline',
    'group-active:text-link-active',
    'border-b',
    'border-divider-subtle',
    'hover:border-link-underline-hover',
    'group-hover:border-link-underline-hover',
    'active:border-link-underline-active',
    'group-active:border-link-underline-active',
    'block'
  ]) %}

	{# Output as space separated list #}
  {{ link_classes|join(' ') }}
{% endmacro %}

{% if not attributes %}
	{% set attributes = create_attribute() %}
{% endif %}
{% set attributes = attributes.addClass(_self.linkClasses(dark, inline, circle) | spaceless) %}
{% if external %}
	{% set attributes = attributes.setAttribute('rel', 'noopener noreferrer').setAttribute('target', '_blank') %}
{% endif %}

<a{{ attributes }} href="{{ url }}">{% apply spaceless %}
	{{ content | raw }}
{% endapply %}</a>
